/*
 * HeartView
 *
 * It is a simple view for the heart beat model.  This just displays
 * the number of heart beats done so far...
 *
 * Most of this code was generated by Visual Cafe's drag and
 * drop GUI builder.  The code that I added is located at the
 * end of the file.
 *
 *@author <a href="http://www.cs.indiana.edu/~cbaray/">cristobal baray</a> cbaray@cs.indiana.edu 
 
 */
 
import java.util.Observer;
import java.util.Observable;

import java.awt.*;
import java.awt.event.*;

public class HeartView extends Frame implements Observer {


	private Label label1;
	private Label heartbeatText;
    // Used for addNotify check.
	private boolean fComponentsAdjusted = false;

	public HeartView() 	{
		setLayout(new FlowLayout(FlowLayout.LEFT,15,5));
		setVisible(false);
		setSize(215,47);
		label1 = new java.awt.Label("Heart beats : ");
		label1.setBounds(15,5,83,25);
		add(label1);
		heartbeatText = new java.awt.Label("                0",Label.RIGHT);
		heartbeatText.setBounds(113,5,55,25);
		add(heartbeatText);
		setTitle("Heart View");
		setResizable(false);

		SymWindow aSymWindow = new SymWindow();
		this.addWindowListener(aSymWindow);
	} // end HeartView constructor

	public HeartView(String title) {
		this();
		setTitle(title);
	} // end HeartView constructor
	
	
	/** 
	 * Constructor that takes a model.  Calls the default
	 * constructor and then registers with the model in order
	 * to be notified on updates.
	 *
	 *@param model The model this view will observe.
	 */
	
	public HeartView(Observable model) {
		this();
		model.addObserver(this);
	} // end HeartView constructor
	
	/**
	 * This is the method required by the Observer interface.
	 * This method will be called whenever the model calls
	 * notifyObservers().
	 *
	 *@param model The model that this object is watching.
	 *@param data The updated data object.
	 */
	public void update(Observable model, Object data) {
		 heartbeatText.setText("" + data);
	}


    /**
     * Shows or hides the component depending on the boolean flag b.
     * @param b  if true, show the component; otherwise, hide the component.
     * @see java.awt.Component#isVisible
     */
    public void setVisible(boolean shouldBeVisible)
	{
		if(shouldBeVisible)
		{
			setLocation(50, 150);
		}
		super.setVisible(shouldBeVisible);
	}

	public void addNotify()
	{
	    // Record the size of the window prior to calling parents addNotify.
	    Dimension d = getSize();
	    
		super.addNotify();

		if (fComponentsAdjusted)
			return;

		// Adjust components according to the insets
		setSize(insets().left + insets().right + d.width, insets().top + insets().bottom + d.height);
		Component components[] = getComponents();
		for (int i = 0; i < components.length; i++)
		{
			Point p = components[i].getLocation();
			p.translate(insets().left, insets().top);
			components[i].setLocation(p);
		}
		fComponentsAdjusted = true;
	}


	class SymWindow extends WindowAdapter {
		public void windowClosing(WindowEvent event) {
			Object object = event.getSource();
			if (object == HeartView.this)
				HeartView.this.setVisible(false);
		} // end windowClosing
	} // end class SymWindow
	

} // end class HeartView
